/* ////////////////////////////////////////////////////////////

  File Name: config.h
  Copyright (c) 2014 Soji Yamakawa.  All rights reserved.
  http://www.ysflight.com

//////////////////////////////////////////////////////////// */

#ifndef CONFIG_IS_INCLUDED
#define CONFIG_IS_INCLUDED
/* { */

#include <ysclass.h>

class PolyCreConfig
{
public:
	YSCOORDSYSMODEL coordSys;
	YsWString defDataDir;
	YSBOOL perspective;

	YsColor bgColor[3];

private:
	PolyCreConfig();
	~PolyCreConfig();
	const PolyCreConfig &operator=(const PolyCreConfig &){}
public:
	static PolyCreConfig *Create(void);
	static void Delete(PolyCreConfig *ptr);

	void Initialize(void);
	void SetDefault(void);
	YSRESULT Load(YsTextInputStream &inStream);
	YSRESULT Load(const wchar_t fn[]);
	YSRESULT Save(YsTextOutputStream &outStream) const;
	YSRESULT Save(const wchar_t fn[]);
};


/* } */
#endif
