#ifndef EDIT_CREATEPRIMITIVEDIALOG_IS_INCLUDED
#define EDIT_CREATEPRIMITIVEDIALOG_IS_INCLUDED
/* { */

#include <fsgui.h>
#include <ysglbuffer.h>

// implemented in edit_createmenu.cpp
class PolyCreCreatePrimitiveDialog : public FsGuiDialog
{
private:
	FsGui3DMainCanvas *canvas;
	FsGuiDropList *primTypeDrp;
	FsGuiTextBox *numDivTxt;
	FsGuiButton *orientationBtn;

	FsGuiButton *okBtn,*cancelBtn;

	PolyCreCreatePrimitiveDialog(){};
	~PolyCreCreatePrimitiveDialog(){};

public:
	YsVec3 box[2];
	int shapeType,orientation,division;
	YsShellExt tmpShl;
	YsGLVertexBuffer vtxBuf;

public:
	static PolyCreCreatePrimitiveDialog *Create(FsGui3DMainCanvas *canvas);
	static void Delete(PolyCreCreatePrimitiveDialog *ptr);

	void Make(void);

	void PrepareShape(void);
private:
	void GetTransformation(YsVec3 &cen,YsVec3 &uVec,YsVec3 &vVec,YsVec3 &wVec) const;
	void PrepareBox(void);
	void PrepareCylinder(void);
	void PrepareEllipsoid(void);
	void PrepareCone(void);

public:
	virtual void OnButtonClick(FsGuiButton *btn);
	virtual void OnTextBoxChange(FsGuiTextBox *txt);
	virtual void OnDropListSelChange(FsGuiDropList *drp,int);
};


class PolyCreParallelogramDialog : public FsGuiDialog
{
private:
	class FsGui3DMainCanvas *canvas;
	FsGuiButton *okBtn,*cancelBtn,*changePointSchemeBtn;

	PolyCreParallelogramDialog();
	~PolyCreParallelogramDialog();
public:
	static PolyCreParallelogramDialog *Create(class FsGui3DMainCanvas *canvas);
	static void Delete(PolyCreParallelogramDialog *ptr);

	YSRESULT Make(void);
	void RemakeDrawingBuffer(void);

	virtual void OnButtonClick(FsGuiButton *btn);
	virtual void OnDropListSelChange(FsGuiDropList *drp,int);
	virtual void OnTextBoxChange(FsGuiTextBox *txt);
	virtual void OnSliderPositionChange(FsGuiSlider *slider,const double &prevPos,const double &prevValue);

	YsGLVertexBuffer lineBuf; // ,triBuf; as required
	YsArray <YsShellVertexHandle> topRow,bottomRow;
	YsArray <YsShellPolygonHandle> plgChain;
	FsGuiButton *closeLoopBtn,*closeLoopFloorCeilingBtn,*cancelLastBtn;
};


class PolyCreEquilateralDialog : public FsGuiDialog
{
private:
	class FsGui3DMainCanvas *canvas;
	FsGuiDropList *takeCursorPosAsDrp;
	FsGuiDropList *whichHalfDrp;
	FsGuiTextBox *numDivTxt;
	FsGuiButton *include2ndVertexBtn;
	FsGuiButton *includeCursorPosBtn;
	FsGuiButton *okBtn,*cancelBtn;

public:
	YsGLVertexBuffer circleBuf,lineBuf;

	class PositionKeyPair
	{
	public:
		YSHASHKEY vtKey;
		YsVec3 vtPos;
	};
	int nSrcVt;
	PositionKeyPair srcVtCache[3];

private:
	PolyCreEquilateralDialog();
	~PolyCreEquilateralDialog();
public:
	static PolyCreEquilateralDialog *Create(class FsGui3DMainCanvas *canvas);
	static void Delete(PolyCreEquilateralDialog *ptr);

	YSRESULT Make(void);
	void RemakeDrawingBuffer(void);

	YSRESULT GetCircumCircle(YsVec3 &cen,double &rad,YsVec3 &uVec,YsVec3 &vVec) const;
	YsArray <YsPair <YsVec3,YsShellVertexHandle> > GetPolygon(void) const;

	virtual void OnButtonClick(FsGuiButton *btn);
	virtual void OnDropListSelChange(FsGuiDropList *drp,int);
	virtual void OnTextBoxChange(FsGuiTextBox *txt);
};


/* } */
#endif
