#ifndef EDIT_SOLIDOFREVOLUTIONDIALOG_IS_INCLUDED
#define EDIT_SOLIDOFREVOLUTIONDIALOG_IS_INCLUDED
/* { */

#include <fsgui.h>

class PolyCreSolidOfRevolutionDialog : public FsGuiDialog
{
private:
	class FsGui3DMainCanvas *canvas;
	FsGuiButton *divCountBtn,*stepAngleBtn;
	FsGuiTextBox *divCountTxt,*stepAngleTxt;
	FsGuiButton *deleteSourcePolygonBtn;
	FsGuiButton *closedBtn;
	FsGuiTextBox *fanAngleTxt;
	FsGuiTextBox *displacementTxt;
	FsGuiButton *smoothnessBtn[3];
	FsGuiButton *reverseBtn;
	FsGuiButton *okBtn,*cancelBtn;

public:
	YsArray <YsShellPolygonHandle> srcPlHdArray;
	YsArray <YsShellExt::ConstEdgeHandle> srcCeHdArray;
	YsShellVertexStore allVtHd;
	YsArray <YsArray <YsShellVertexHandle> > srcBoundaryArray;
	YsShellVertexHandle axisVtHd[2];
	const YsShellExt *shl;

	YsShellVertexHandle axisSelVtHd[2];   // For restoring selection after making a solid of revolution.
	YsShellExt::ConstEdgeHandle axisSelCeHd; // For restoring selection after making a solid of revolution.

	YsHashTable <YsArray <YsVec3> > srcVtKeyToPathPosHash;
	YsGLVertexBuffer lineBuf;

private:
	PolyCreSolidOfRevolutionDialog();
	~PolyCreSolidOfRevolutionDialog();
public:
	static PolyCreSolidOfRevolutionDialog *Create(class FsGui3DMainCanvas *canvas);
	static void Delete(PolyCreSolidOfRevolutionDialog *ptr);

	YSRESULT Make(void);
	void RemakeSrcVtKeyToPathPosHash(const YsShellExt &shl);
	void RemakeDrawingBuffer(void);

	void CleanUp(const YsShellExt &shl);

	int GetDivisionCount(void) const;
	YSBOOL CloseLoop(void) const;
	YSBOOL DeleteSourcePolygon(void) const;

	virtual void OnButtonClick(FsGuiButton *btn);
	virtual void OnDropListSelChange(FsGuiDropList *drp,int);
	virtual void OnTextBoxChange(FsGuiTextBox *txt);
	virtual void OnSliderPositionChange(FsGuiSlider *slider,const double &prevPos,const double &prevValue);
};

/* } */
#endif
