/* ////////////////////////////////////////////////////////////

  File Name: edit_sweepdialog.h
  Copyright (c) 2014 Soji Yamakawa.  All rights reserved.
  http://www.ysflight.com

//////////////////////////////////////////////////////////// */

#ifndef EDIT_SWEEPDIALOG_IS_INCLUDED
#define EDIT_SWEEPDIALOG_IS_INCLUDED
/* { */

#include <fsgui.h>
#include <ysglbuffer.h>

#include <ysshellext_sweeputil.h>

class PolyCreEditParallelSweepDialog : public FsGuiDialog
{
private:
	PolyCreEditParallelSweepDialog(){};
	~PolyCreEditParallelSweepDialog(){};

	class FsGui3DMainCanvas *canvas;
	FsGuiButton *okBtn,*cancelBtn;
	FsGuiTextBox *scaleTxt;
	FsGuiButton *deleteSourcePolygonBtn;

public:
	static PolyCreEditParallelSweepDialog *Create(void);
	static void Delete(PolyCreEditParallelSweepDialog *dlg);

	void Make(class FsGui3DMainCanvas *canvas);
	double GetScalingFactor(void) const;

	void SetDeleteSourcePolygon(YSBOOL sw);
	YSBOOL GetDeleteSourcePolygon(void) const;

	void OnButtonClick(FsGuiButton *btn);
};

////////////////////////////////////////////////////////////

class PolyCreEditParallelSweepWithPathDialog : public FsGuiDialog
{
private:
	PolyCreEditParallelSweepWithPathDialog();
	~PolyCreEditParallelSweepWithPathDialog();

public:
	class FsGui3DMainCanvas *canvas;
	FsGuiButton *okBtn,*cancelBtn;
	FsGuiButton *deleteSourcePolygonBtn;
	YsArray <FsGuiTextBox *> scaleTxt;

	YsArray <YsShellPolygonHandle> srcPlHdCache;
	YsArray <YsShellVertexHandle> pathVtHdCache;
	YsArray <double> scaling;

	YsShellExt_SweepInfoMultiStep sweepUtil;
	YsGLVertexBuffer lineBuf;

public:
	static PolyCreEditParallelSweepWithPathDialog *Create(FsGui3DMainCanvas *canvas);
	static void Delete(PolyCreEditParallelSweepWithPathDialog *ptr);

	YSRESULT Make(void);
	YSBOOL GetDeleteSourcePolygon(void) const;

	void SetUpParallelSweepWithPath(void);
	void RemakeDrawingBuffer(void);

	void OnButtonClick(FsGuiButton *btn);
	void OnTextBoxChange(FsGuiTextBox *txt);
};

#include <ysshellext_patchutil.h>

class PolyCreEditSweepConstEdgeDialog : public FsGuiDialog
{
private:
	class FsGui3DMainCanvas *canvas;
	FsGuiButton *okBtn,*cancelBtn,*invertBtn;

	PolyCreEditSweepConstEdgeDialog();
	~PolyCreEditSweepConstEdgeDialog();
public:
	YsArray <YsShellExt::ConstEdgeHandle> ceHdArray;
	YsArray <YsShellExt_PatchBetweenTwoConstEdge> patchUtil;

	YsGLVertexBuffer lineBuf;
	YsGLVertexBuffer triBuf;

	static PolyCreEditSweepConstEdgeDialog *Create(FsGui3DMainCanvas *canvas);
	static void Delete(PolyCreEditSweepConstEdgeDialog *ptr);

	void CleanUp(void);
	void Make(void);
	YSRESULT SetUp(void);

	void OnButtonClick(FsGuiButton *btn);

	void RecalculateNormal(void);
	void RemakeDrawingBuffer(void);
};

////////////////////////////////////////////////////////////

class PolyCreExtendOrShrinkDialog : public FsGuiDialog
{
private:
	FsGuiButton *okBtn,*cancelBtn;
	FsGui3DMainCanvas *canvas;

public:
	class ToExtend
	{
	public:
		YsShellVertexHandle fromVtHd,toVtHd;
		YsVec3 org,vec,newPos;
	};
	YsArray <ToExtend> extensionTarget;
	YsGLVertexBuffer lineBuf,triBuf;

	YsVec3 moveDir,center;
	YsShellExtEdit *shl;
	YsArray <YsShellPolygonHandle> targetPlHdArray;

private:
	PolyCreExtendOrShrinkDialog();
	~PolyCreExtendOrShrinkDialog();

public:
	static PolyCreExtendOrShrinkDialog *Create(FsGui3DMainCanvas *canvas);
	static void Delete(PolyCreExtendOrShrinkDialog *ptr);

	YSRESULT Make(class YsShellExtEdit &shl,const YsShellPolygonStore &targetPlHdStore);

	void RemakeDrawingBuffer(void);

	void OnButtonClick(FsGuiButton *btn);
};

/* } */
#endif
