/* ////////////////////////////////////////////////////////////

  File Name: refbmpdialog.h
  Copyright (c) 2014 Soji Yamakawa.  All rights reserved.
  http://www.ysflight.com

//////////////////////////////////////////////////////////// */

#ifndef REFBMPDIALOG_IS_INCLUDED
#define REFBMPDIALOG_IS_INCLUDED
/* { */

#include <fsgui.h>

class PolyCreRefBmpDialog : public FsGuiDialog
{
private:
	class FsGui3DMainCanvas *canvas;
	class PolyCreReferenceBitmapStore *refBmpStore;

	FsGuiDropList *bmpIdxDrp;
	FsGuiButton *centerBtn,*xyBtn,*xzBtn,*yzBtn;

	FsGuiButton *moveBtn,*rotateBtn;

	FsGuiButton *loadBtn,*discardBtn;

	FsGuiButton *showBtn;

	FsGuiButton *closeBtn;

	FsGuiMessageBoxDialog *mbox;

	FsGuiSlider *transparencySlider;


	class FsGuiFileDialog *fdlg;

	YsVec3 orgCorner[4];

private:
	PolyCreRefBmpDialog();
	~PolyCreRefBmpDialog();

public:
	static PolyCreRefBmpDialog *Create(void);
	static void Delete(PolyCreRefBmpDialog *ptr);

	void Make(class FsGui3DMainCanvas *canvas,class PolyCreReferenceBitmapStore *refBmpStore);

	int GetSelectedBitmapIndex(void) const;

	virtual void OnButtonClick(FsGuiButton *btn);
    virtual void OnModalDialogClosed(int dialogIdent,class FsGuiDialog *closedModalDialog,int modalDialogEndCode);
	virtual void OnDropListSelChange(FsGuiDropList *drp,int prevSel);
	virtual void OnSliderPositionChange(FsGuiSlider *slider,const double &prevPos,const double &prevValue);

	static void ThreeDInterfaceCallBack(void *contextPtr,FsGui3DInterface &itfc);
private:
	void ConfigureForBitmapIndex(int bmpIdx);
};

/* } */
#endif
