#include <unistd.h>
#include <sys/stat.h>

#include <ysclass.h>
#include "../ysspecialpath.h"

YSRESULT YsSpecialPath::GetProgramFileName(YsString &path)
{
	int n;
	char buf[MaxPath];
	n=readlink("/proc/self/exe",buf,MaxPath-1);
	if(0<=n)
	{
		buf[n]=0;
		path.Set(buf);
		return YSOK;
	}
	return YSERR;
}

YSRESULT YsSpecialPath::GetProgramFileName(YsWString &wpath)
{
	YsString path;
	if(YSOK==GetProgramFileName(path))
	{
		wpath.SetUTF8String(path);
		return YSOK;
	}
	return YSERR;
}

YSRESULT YsSpecialPath::GetProgramBaseDir(YsString &path)
{
	YsString ful;
	if(YSOK==GetProgramFileName(ful))
	{
		YsString fil;
		ful.SeparatePathFile(path,fil);
		return YSOK;
	}
	return YSERR;
}

YSRESULT YsSpecialPath::GetProgramBaseDir(YsWString &wpath)
{
	YsString path;
	if(YSOK==GetProgramBaseDir(path))
	{
		wpath.SetUTF8String(path);
		return YSOK;
	}
	return YSERR;
}

YSRESULT YsSpecialPath::GetUserDir(YsString &path)
{
	const char *homeDir=getenv("HOME");
	if(NULL!=homeDir)
	{
		path.Set(homeDir);
		return YSOK;
	}
	return YSERR;
}

YSRESULT YsSpecialPath::GetUserDir(YsWString &wpath)
{
	const char *homeDir=getenv("HOME");
	if(NULL!=homeDir)
	{
		wpath.SetUTF8String(homeDir);
		return YSOK;
	}
	return YSERR;
}

YSRESULT YsSpecialPath::GetUserDocDir(YsString &path)
{
	const char *homeDir=getenv("HOME");
	if(NULL!=homeDir)
	{
		path.MakeFullPathName(homeDir,"Documents");
		mkdir(path,493); // 0755
		return YSOK;
	}
	return YSERR;
}

YSRESULT YsSpecialPath::GetUserDocDir(YsWString &wpath)
{
	YsString path;
	if(YSOK==GetUserDocDir(path))
	{
		wpath.SetUTF8String(path);
		return YSOK;
	}
	return YSERR;
}

YSRESULT YsSpecialPath::GetUserAppDataDir(YsString &path)
{
	const char *homeDir=getenv("HOME");
	if(NULL!=homeDir)
	{
		path.MakeFullPathName(homeDir,"ApplicationData");
		mkdir(path,493); // 0755
		return YSOK;
	}
	return YSERR;
}

YSRESULT YsSpecialPath::GetUserAppDataDir(YsWString &wpath)
{
	YsString path;
	if(YSOK==GetUserAppDataDir(path))
	{
		wpath.SetUTF8String(path);
		return YSOK;
	}
	return YSERR;
}

YSRESULT YsSpecialPath::GetAllUsersDir(YsString &path)
{
	return YSERR;
}

YSRESULT YsSpecialPath::GetAllUsersDir(YsWString &path)
{
	return YSERR;
}

