#ifndef YSENCODING_IS_INCLUDED
#define YSENCODING_IS_INCLUDED
/* { */

/*! \file */

#include <ysclass.h>

/*! This function converts a system-encoding string into a unicode string.
    In the current implementation, it assumes the system encoding is UTF8 in MacOSX and Linux. 
    This assumption must be ok with MacOSX, but may cause some issues in Linux which uses
    non-UTF8 encoding as default encoding. */
YSRESULT YsSystemEncodingToUnicode(YsWString &unicode,const char systemEncoding[]);

/*! This function convers a unicode string into a system-encoding string. 
    In the current implementation, it assumes the system encoding is UTF8 in MacOSX and Linux. 
    This assumption must be ok with MacOSX, but may cause some issues in Linux which uses
    non-UTF8 encoding as default encoding. */
YSRESULT YsUnicodeToSystemEncoding(YsString &systemEncoding,const wchar_t unicode[]);

/* } */
#endif
